ALTER TABLE M_NNSTOMAR
ADD ID_VOUCHER_TYPE NUMBER;

ALTER TABLE M_NNSTOMAR
ADD VOUCHER_AMOUNT NUMBER;

CREATE TABLE VOUCHER_PAYMENT_RULE (
ID_VOUCHER_PAYMENT_RULE NUMBER NOT NULL,
ID_VOUCHER_TYPE NUMBER,
SERVICE_CODE VARCHAR2(6 CHAR),
ID_ARTIKEL NUMBER,
CONSTRAINT VOUCHER_PAYMENT_RULE_PK PRIMARY KEY (ID_VOUCHER_PAYMENT_RULE),
CONSTRAINT VPR_SERVICE_CODE_FK FOREIGN KEY (SERVICE_CODE) REFERENCES M_NNSTOMAR(SIFRA),
CONSTRAINT VPR_ID_ARTIKEL_FK FOREIGN KEY (ID_ARTIKEL) REFERENCES S_ARTIKLI(ID_ARTIKEL)
);

CREATE INDEX IX_VPR_SERVICE_CODE ON VOUCHER_PAYMENT_RULE (SERVICE_CODE);
CREATE INDEX IX_VPR_ID_ARTIKEL ON VOUCHER_PAYMENT_RULE (ID_ARTIKEL);

CREATE SEQUENCE VOUCHER_PAYMENT_RULE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_VOUCHER_PAYMENT_RULE AS (
SELECT V.ID_VOUCHER_PAYMENT_RULE, V.ID_VOUCHER_TYPE, V.SERVICE_CODE, V.ID_ARTIKEL, MS.OPIS AS SERVICE_DESCRIPTION, SA.NAZIV1 AS ARTICLE_DESCRIPTION
FROM VOUCHER_PAYMENT_RULE V
LEFT OUTER JOIN M_NNSTOMAR MS ON MS.SIFRA = V.SERVICE_CODE
LEFT OUTER JOIN S_ARTIKLI SA ON SA.ID_ARTIKEL = V.ID_ARTIKEL
);

DROP VIEW V_RACUN_DATA;

CREATE OR REPLACE VIEW V_RACUN_DATA AS (
  SELECT R.ID_RACUN_DATA, R.N_RACUNA, R.KOLICINA, R.ZN_DAVKA, R.CENABD, R.ZNESEK, R.ID_OBRACUN, R.ID_STORITVE, R.ID_SALDKONT, R.ZAP_ST, R.POPUST, R.DAV_STOPNJA, R.STORNO, 
  R.ST_DN, R.RN_TEKST, R.AVT_FAKT, R.NETO, R.NON_REFUND, R.TIP, R.ID_STORITVE_GEN, R.DEPOSIT_AMOUNT, R.DATUM_OD, R.DATUM_DO, R.KOMENTAR, 
  S.ZA_PLACILO AS SALDKONT_ZA_PLACILO, S.PORABLJENO AS SALDKONT_PORABLJENO, S.ZNESEK AS SALDKONT_ZNESEK, S.ID_KUPCA AS SALDKONT_ID_KUPCA, S.ID_PLOVILA AS SALDKONT_ID_PLOVILA, 
  S.TECAJ_VALUTE AS SALDKONT_TECAJ_VALUTE,S.TECAJ_PRERACUN AS SALDKONT_TECAJ_PRERACUN, S.VALUTA_RN AS SALDKONT_VALUTA_RN, S.STOAK AS SALDKONT_STOAK, S.N_RACUNA AS SALDKONT_N_RACUNA, S.DATUM AS SALDKONT_DATUM,
  S.DATUM_VALUTACIJE AS SALDKONT_DATUM_VALUTACIJE, S.SDK_RN_PL AS SALDKONT_SDK_RN_PL, S.SDK_RN_TIP AS SALDKONT_SDK_RN_TIP, S.NNLOCATION_ID AS SALDKONT_NNLOCATION_ID, S.R_EXPORT_NR AS SALDKONT_EXPORT_NR,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.EMAIL AS KUPCI_EMAIL, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.NDRZAVA AS KUPCI_NDRZAVA, ND.OPIS AS KUPCI_DRZAVA_OPIS,
  NK.SLO AS KNJIZBA_OPIS, SD.OPIS AS DAVEK_OPIS, SO.ID_ARTIKEL AS OBRACUN_ID_ARTIKEL, SO.OPIS AS OBRACUN_OPIS, SE.NAZIV AS OBRACUN_ENOTA_NAZIV, M.STORITEV AS STORITVE_STORITEV, M.NCARD AS STORITVE_NCARD, 
  N.OPIS AS NNSTOMAR_OPIS, N.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, N.TRIGGER_DEPOSIT AS NNSTOMAR_TRIGGER_DEPOSIT, NE.OPIS AS NNSTOMAR_ENOTA_OPIS,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.OPIS IS NOT NULL THEN N.OPIS ELSE NK.SLO END) END) AS TITLE,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.INTERNI_OPIS IS NOT NULL THEN N.INTERNI_OPIS ELSE NK.INTERNI_OPIS END) END) AS INTERNAL_TITLE,
  (SELECT SUM(NVL(ZN_DAVKA, 0)) FROM RACUN_DATA WHERE ID_SALDKONT = R.ID_SALDKONT) AS ZN_DAVKA_SUM
	FROM RACUN_DATA R
  LEFT OUTER JOIN SALDKONT S ON S.ID_SALDKONT = R.ID_SALDKONT
  LEFT OUTER JOIN NKNJIZBA NK ON NK.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN KUPCI K ON K.ID = S.ID_KUPCA
  LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = K.NDRZAVA
  LEFT OUTER JOIN S_DAVEK SD ON SD.ID_DAVEK = R.ID_DAVEK
  LEFT OUTER JOIN S_OBRACUN SO ON SO.ID_OBRACUN = R.ID_OBRACUN
  LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SO.ID_ENOTA
  LEFT OUTER JOIN M_STORITVE M ON M.ID_STORITVE = R.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR N ON N.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NE ON NE.SIFRA = ENOTA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1710, SYSDATE, '5.5', 1630, 'Voucher pay rules')
;