ALTER TABLE DATOTEKE_PLOVIL
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE DATOTEKE_PLOVIL P
SET P.ID_HASH = ORA_HASH (P.ID_DATOTEKE_PLOVIL || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE DATOTEKE_PLOVIL P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER DATOTEKE_PLOVIL_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON DATOTEKE_PLOVIL
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_DATOTEKE_PLOVIL || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE DATOTEKE_KUPCEV
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE DATOTEKE_KUPCEV P
SET P.ID_HASH = ORA_HASH (P.ID_DATOTEKE_KUPCEV || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE DATOTEKE_KUPCEV P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER DATOTEKE_KUPCEV_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON DATOTEKE_KUPCEV
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_DATOTEKE_KUPCEV || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE DATOTEKE_PRIVEZOV
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE DATOTEKE_PRIVEZOV P
SET P.ID_HASH = ORA_HASH (P.ID_DATOTEKE_PRIVEZOV || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE DATOTEKE_PRIVEZOV P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER DATOTEKE_PRIVEZOV_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON DATOTEKE_PRIVEZOV
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_DATOTEKE_PRIVEZOV || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE PRINT_DOK
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE PRINT_DOK P
SET P.ID_HASH = ORA_HASH (P.ID_PRINT_DOK || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE PRINT_DOK P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER PRINT_DOK_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON PRINT_DOK
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_PRINT_DOK || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE DOCUMENT_FILES
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE DOCUMENT_FILES P
SET P.ID_HASH = ORA_HASH (P.ID_DOC_FILES || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE DOCUMENT_FILES P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER DOCUMENT_FILES_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON DOCUMENT_FILES
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_DOC_FILES || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE FILE_DATA
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE FILE_DATA P
SET P.ID_HASH = ORA_HASH (P.ID_FILE_DATA || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE FILE_DATA P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER FILE_DATA_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON FILE_DATA
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_FILE_DATA || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2147, SYSDATE, '5.5', 2067, 'IdHash triggers')
;

